"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RecipientState = exports.RecipientSlot = exports.RecipientSlotShare = exports.RecipientSlotOwnerAssigned = exports.RecipientSlotOwnerUnassigned = exports.RecipientSlotOwner = exports.ServerState = exports.RegistryState = exports.GameReg = exports.GameState = exports.PlayerJoin = exports.ServerJoin = exports.Vote = exports.PlayerState = void 0;
const utils_1 = require("./utils");
const RaceCore = __importStar(require("@race-foundation/sdk-core"));
const sdk_core_1 = require("@race-foundation/sdk-core");
const borsh_1 = require("@race-foundation/borsh");
const RECIPIENT_SLOT_TYPE = {
    Nft: 0,
    Token: 1
};
class PlayerState {
    constructor(fields) {
        Object.assign(this, fields);
    }
    serialize() {
        return (0, borsh_1.serialize)(this);
    }
    static deserialize(data) {
        return (0, borsh_1.deserialize)(PlayerState, data);
    }
    generalize(addr) {
        return new RaceCore.PlayerProfile({
            addr: addr.toBase58(),
            nick: this.nick,
            pfp: this.pfpKey?.toBase58(),
        });
    }
}
__decorate([
    (0, borsh_1.field)('bool')
], PlayerState.prototype, "isInitialized", void 0);
__decorate([
    (0, borsh_1.field)('string')
], PlayerState.prototype, "nick", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.option)(utils_1.publicKeyExt))
], PlayerState.prototype, "pfpKey", void 0);
exports.PlayerState = PlayerState;
class Vote {
    constructor(fields) {
        Object.assign(this, fields);
    }
    generalize() {
        return new RaceCore.Vote({
            voter: this.voterKey.toBase58(),
            votee: this.voteeKey.toBase58(),
            voteType: this.voteType,
        });
    }
}
__decorate([
    (0, borsh_1.field)(utils_1.publicKeyExt)
], Vote.prototype, "voterKey", void 0);
__decorate([
    (0, borsh_1.field)(utils_1.publicKeyExt)
], Vote.prototype, "voteeKey", void 0);
__decorate([
    (0, borsh_1.field)('u8')
], Vote.prototype, "voteType", void 0);
exports.Vote = Vote;
class ServerJoin {
    constructor(fields) {
        Object.assign(this, fields);
    }
    generalize() {
        return new RaceCore.ServerJoin({
            addr: this.key.toBase58(),
            endpoint: this.endpoint,
            accessVersion: this.accessVersion,
            verifyKey: this.verifyKey,
        });
    }
}
__decorate([
    (0, borsh_1.field)(utils_1.publicKeyExt)
], ServerJoin.prototype, "key", void 0);
__decorate([
    (0, borsh_1.field)('string')
], ServerJoin.prototype, "endpoint", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], ServerJoin.prototype, "accessVersion", void 0);
__decorate([
    (0, borsh_1.field)('string')
], ServerJoin.prototype, "verifyKey", void 0);
exports.ServerJoin = ServerJoin;
class PlayerJoin {
    constructor(fields) {
        Object.assign(this, fields);
    }
    generalize() {
        return new RaceCore.PlayerJoin({
            addr: this.key.toBase58(),
            position: this.position,
            balance: this.balance,
            accessVersion: this.accessVersion,
            verifyKey: this.verifyKey,
        });
    }
}
__decorate([
    (0, borsh_1.field)(utils_1.publicKeyExt)
], PlayerJoin.prototype, "key", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], PlayerJoin.prototype, "balance", void 0);
__decorate([
    (0, borsh_1.field)('u16')
], PlayerJoin.prototype, "position", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], PlayerJoin.prototype, "accessVersion", void 0);
__decorate([
    (0, borsh_1.field)('string')
], PlayerJoin.prototype, "verifyKey", void 0);
exports.PlayerJoin = PlayerJoin;
class GameState {
    constructor(fields) {
        Object.assign(this, fields);
    }
    serialize() {
        return (0, borsh_1.serialize)(this);
    }
    static deserialize(data) {
        return (0, borsh_1.deserialize)(GameState, data);
    }
    generalize(addr) {
        return new RaceCore.GameAccount({
            addr: addr.toBase58(),
            title: this.title,
            bundleAddr: this.bundleKey.toBase58(),
            ownerAddr: this.ownerKey.toBase58(),
            tokenAddr: this.tokenKey.toBase58(),
            deposits: [],
            transactorAddr: this.transactorKey?.toBase58(),
            accessVersion: this.accessVersion,
            settleVersion: this.settleVersion,
            maxPlayers: this.maxPlayers,
            players: this.players.map(p => p.generalize()),
            servers: this.servers.map(s => s.generalize()),
            dataLen: this.dataLen,
            data: this.data,
            votes: this.votes.map(v => v.generalize()),
            unlockTime: this.unlockTime,
            entryType: this.entryType,
            recipientAddr: this.recipientAddr.toBase58(),
        });
    }
}
__decorate([
    (0, borsh_1.field)('bool')
], GameState.prototype, "isInitialized", void 0);
__decorate([
    (0, borsh_1.field)('string')
], GameState.prototype, "title", void 0);
__decorate([
    (0, borsh_1.field)(utils_1.publicKeyExt)
], GameState.prototype, "bundleKey", void 0);
__decorate([
    (0, borsh_1.field)(utils_1.publicKeyExt)
], GameState.prototype, "stakeKey", void 0);
__decorate([
    (0, borsh_1.field)(utils_1.publicKeyExt)
], GameState.prototype, "ownerKey", void 0);
__decorate([
    (0, borsh_1.field)(utils_1.publicKeyExt)
], GameState.prototype, "tokenKey", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.option)(utils_1.publicKeyExt))
], GameState.prototype, "transactorKey", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], GameState.prototype, "accessVersion", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], GameState.prototype, "settleVersion", void 0);
__decorate([
    (0, borsh_1.field)('u16')
], GameState.prototype, "maxPlayers", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.array)((0, borsh_1.struct)(PlayerJoin)))
], GameState.prototype, "players", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.array)((0, borsh_1.struct)(ServerJoin)))
], GameState.prototype, "servers", void 0);
__decorate([
    (0, borsh_1.field)('u32')
], GameState.prototype, "dataLen", void 0);
__decorate([
    (0, borsh_1.field)('u8-array')
], GameState.prototype, "data", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.array)((0, borsh_1.struct)(Vote)))
], GameState.prototype, "votes", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.option)('u64'))
], GameState.prototype, "unlockTime", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.enums)(sdk_core_1.EntryType))
], GameState.prototype, "entryType", void 0);
__decorate([
    (0, borsh_1.field)(utils_1.publicKeyExt)
], GameState.prototype, "recipientAddr", void 0);
exports.GameState = GameState;
class GameReg {
    constructor(fields) {
        Object.assign(this, fields);
    }
    generalize() {
        return new RaceCore.GameRegistration({
            title: this.title,
            addr: this.gameKey.toBase58(),
            bundleAddr: this.bundleKey.toBase58(),
            regTime: this.regTime,
        });
    }
}
__decorate([
    (0, borsh_1.field)('string')
], GameReg.prototype, "title", void 0);
__decorate([
    (0, borsh_1.field)(utils_1.publicKeyExt)
], GameReg.prototype, "gameKey", void 0);
__decorate([
    (0, borsh_1.field)(utils_1.publicKeyExt)
], GameReg.prototype, "bundleKey", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], GameReg.prototype, "regTime", void 0);
exports.GameReg = GameReg;
class RegistryState {
    constructor(fields) {
        Object.assign(this, fields);
    }
    serialize() {
        return (0, borsh_1.serialize)(this);
    }
    static deserialize(data) {
        return (0, borsh_1.deserialize)(RegistryState, data);
    }
    generalize(addr) {
        return new RaceCore.RegistrationAccount({
            addr: addr.toBase58(),
            isPrivate: this.isPrivate,
            size: this.size,
            owner: this.ownerKey.toBase58(),
            games: this.games.map(g => g.generalize()),
        });
    }
}
__decorate([
    (0, borsh_1.field)('bool')
], RegistryState.prototype, "isInitialized", void 0);
__decorate([
    (0, borsh_1.field)('bool')
], RegistryState.prototype, "isPrivate", void 0);
__decorate([
    (0, borsh_1.field)('u16')
], RegistryState.prototype, "size", void 0);
__decorate([
    (0, borsh_1.field)(utils_1.publicKeyExt)
], RegistryState.prototype, "ownerKey", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.array)((0, borsh_1.struct)(GameReg)))
], RegistryState.prototype, "games", void 0);
exports.RegistryState = RegistryState;
class ServerState {
    constructor(fields) {
        Object.assign(this, fields);
    }
    serialize() {
        return (0, borsh_1.serialize)(this);
    }
    static deserialize(data) {
        return (0, borsh_1.deserialize)(this, data);
    }
    generalize() {
        return new RaceCore.ServerAccount({
            addr: this.ownerKey.toBase58(),
            endpoint: this.endpoint,
        });
    }
}
__decorate([
    (0, borsh_1.field)('bool')
], ServerState.prototype, "isInitialized", void 0);
__decorate([
    (0, borsh_1.field)(utils_1.publicKeyExt)
], ServerState.prototype, "key", void 0);
__decorate([
    (0, borsh_1.field)(utils_1.publicKeyExt)
], ServerState.prototype, "ownerKey", void 0);
__decorate([
    (0, borsh_1.field)('string')
], ServerState.prototype, "endpoint", void 0);
exports.ServerState = ServerState;
class RecipientSlotOwner {
}
exports.RecipientSlotOwner = RecipientSlotOwner;
let RecipientSlotOwnerUnassigned = class RecipientSlotOwnerUnassigned extends RecipientSlotOwner {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
};
__decorate([
    (0, borsh_1.field)('string')
], RecipientSlotOwnerUnassigned.prototype, "identifier", void 0);
RecipientSlotOwnerUnassigned = __decorate([
    (0, borsh_1.variant)(0)
], RecipientSlotOwnerUnassigned);
exports.RecipientSlotOwnerUnassigned = RecipientSlotOwnerUnassigned;
let RecipientSlotOwnerAssigned = class RecipientSlotOwnerAssigned extends RecipientSlotOwner {
    constructor(fields) {
        super();
        Object.assign(this, fields);
    }
};
__decorate([
    (0, borsh_1.field)(utils_1.publicKeyExt)
], RecipientSlotOwnerAssigned.prototype, "addr", void 0);
RecipientSlotOwnerAssigned = __decorate([
    (0, borsh_1.variant)(1)
], RecipientSlotOwnerAssigned);
exports.RecipientSlotOwnerAssigned = RecipientSlotOwnerAssigned;
class RecipientSlotShare {
    constructor(fields) {
        Object.assign(this, fields);
    }
    generalize() {
        let owner;
        if (this.owner instanceof RecipientSlotOwnerAssigned) {
            owner = new RaceCore.RecipientSlotOwnerAssigned({ addr: this.owner.addr.toBase58() });
        }
        else if (this.owner instanceof RecipientSlotOwnerUnassigned) {
            owner = new RaceCore.RecipientSlotOwnerUnassigned({ identifier: this.owner.identifier });
        }
        else {
            throw new Error('Invalid slot owner');
        }
        return new RaceCore.RecipientSlotShare({
            owner, weights: this.weights, claimAmount: this.claimAmount, claimAmountCap: this.claimAmountCap
        });
    }
}
__decorate([
    (0, borsh_1.field)((0, borsh_1.enums)(RecipientSlotOwner))
], RecipientSlotShare.prototype, "owner", void 0);
__decorate([
    (0, borsh_1.field)('u16')
], RecipientSlotShare.prototype, "weights", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], RecipientSlotShare.prototype, "claimAmount", void 0);
__decorate([
    (0, borsh_1.field)('u64')
], RecipientSlotShare.prototype, "claimAmountCap", void 0);
exports.RecipientSlotShare = RecipientSlotShare;
class RecipientSlot {
    constructor(fields) {
        Object.assign(this, fields);
    }
    generalize() {
        return new RaceCore.RecipientSlot({
            id: this.id,
            slotType: this.slotType,
            tokenAddr: this.tokenAddr.toBase58(),
            shares: this.shares.map(s => s.generalize()),
        });
    }
}
__decorate([
    (0, borsh_1.field)('u8')
], RecipientSlot.prototype, "id", void 0);
__decorate([
    (0, borsh_1.field)('u8')
], RecipientSlot.prototype, "slotType", void 0);
__decorate([
    (0, borsh_1.field)(utils_1.publicKeyExt)
], RecipientSlot.prototype, "tokenAddr", void 0);
__decorate([
    (0, borsh_1.field)(utils_1.publicKeyExt)
], RecipientSlot.prototype, "stakeAddr", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.array)((0, borsh_1.struct)(RecipientSlotShare)))
], RecipientSlot.prototype, "shares", void 0);
exports.RecipientSlot = RecipientSlot;
class RecipientState {
    constructor(fields) {
        Object.assign(this, fields);
    }
    serialize() {
        return (0, borsh_1.serialize)(this);
    }
    static deserialize(data) {
        return (0, borsh_1.deserialize)(this, data);
    }
    generalize() {
        return new RaceCore.RecipientAccount({
            addr: this.addr.toBase58(),
            capAddr: this.capAddr?.toBase58(),
            slots: this.slots.map(s => s.generalize()),
        });
    }
}
__decorate([
    (0, borsh_1.field)(utils_1.publicKeyExt)
], RecipientState.prototype, "addr", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.option)(utils_1.publicKeyExt))
], RecipientState.prototype, "capAddr", void 0);
__decorate([
    (0, borsh_1.field)((0, borsh_1.array)((0, borsh_1.struct)(RecipientSlot)))
], RecipientState.prototype, "slots", void 0);
exports.RecipientState = RecipientState;
//# sourceMappingURL=accounts.js.map